%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%global commit 28cc7276784bcc4d8a1be6854a6add1145ec4109

Name:           graphite-web
Version:        0.9.12
Release:        1%{?dist}

Packager :      Django <django@mailserver.guru>
Distribution:   CentOS 7

Summary:        A Django web application for enterprise scalable realtime graphing
Group:          Applications/Internet
License:        ASL 2.0
URL:            https://github.com/graphite-project

Source0:        https://github.com/graphite-project/graphite-web/archive/%{commit}/%{name}-%{commit}.tar.gz
Source1:        graphite-web-vhost.conf
Source2:        graphite-web-README.fedora
Source10:       %{name}.logrotate
Patch0:         %{name}-0.9.12-Amend-default-filesystem-locations.patch
Patch1:         %{name}-0.9.12-Force-use-of-system-libraries.patch
Patch2:         %{name}-0.9.12-carbonlink-exception-log.patch
Patch3:         %{name}-0.9.12-dashboard-load.patch
Patch4:         %{name}-0.9.12-safe-unpickle-deque-addition.patch
Patch5:         %{name}-0.9.12-Fix-build-index.sh-variables.patch
Patch6:         %{name}-0.9.12-Changes-for-django-1.5.patch
Patch7:         %{name}-0.9.12-Disable-internal-log-rotation.patch

BuildArch:      noarch
BuildRequires:  python-devel

Requires:       dejavu-sans-fonts
Requires:       dejavu-serif-fonts
Requires:       django-tagging
Requires:       mod_wsgi
Requires:       pycairo
Requires:       pyparsing
Requires:       python-simplejson
Requires:       python-whisper >= %{version}
Requires:       pytz

%if 0%{?fedora} >= 18 || 0%{?rhel} >= 7
Requires:       python-django >= 1.3
%else
Requires:       Django >= 1.3
%endif

%if 0%{?el5}
Requires:       python-sqlite2
%endif

Obsoletes:      %{name}-selinux < 0.9.12-7


%description
Graphite consists of a storage backend and a web-based visualization frontend.
Client applications send streams of numeric time-series data to the Graphite
backend (called carbon), where it gets stored in fixed-size database files
similar in design to RRD. The web frontend provides user interfaces
for visualizing this data in graphs as well as a simple URL-based API for
direct graph generation.

Graphite's design is focused on providing simple interfaces (both to users and
applications), real-time visualization, high-availability, and enterprise
scalability.


%prep
%setup -q -n graphite-web-%{commit}
rm -rf webapp/graphite/thirdparty
find -type f -iname '*.swf' -delete

install -m0644 %{SOURCE2} README.fedora

# Amend default filesystem locations.
%patch0 -p1

# Force use of system libraries.
%patch1 -p1

# To help diagnose some exceptions.
# https://github.com/graphite-project/graphite-web/pull/446
%patch2 -p1

# Dashboard not loading when passed as /dashboard/name.
# https://github.com/graphite-project/graphite-web/issues/411
%patch3 -p1

# Add deque to the PICKLE_SAFE filter.
# https://github.com/graphite-project/graphite-web/issues/423
%patch4 -p1

# Fix filesystem locations for variables in build-index.sh.
%patch5 -p1

%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
# Changes needed to run without warning using Django 1.5.
# https://github.com/graphite-project/graphite-web/commit/fc3f018
%patch6 -p1
%endif

# Disable internal log rotation.
%patch7 -p1


%build
%{__python2} setup.py build


%install
%{__python2} setup.py install --optimize=1 --skip-build --root %{buildroot} \
    --install-lib=%{python_sitelib} \
    --install-data=%{_datadir}/graphite \
    --install-scripts=%{_bindir}

mkdir -p %{buildroot}%{_localstatedir}/lib/graphite-web
mkdir -p %{buildroot}%{_localstatedir}/log/graphite-web
mkdir -p %{buildroot}%{_sysconfdir}/graphite-web

install -Dp -m0644 webapp/graphite/local_settings.py.example \
    %{buildroot}%{_sysconfdir}/graphite-web/local_settings.py
ln -s %{_sysconfdir}/graphite-web/local_settings.py \
    %{buildroot}%{python_sitelib}/graphite/local_settings.py
install -Dp -m0644 conf/dashboard.conf.example  \
    %{buildroot}%{_sysconfdir}/graphite-web/dashboard.conf
install -Dp -m0644 %{SOURCE1} \
    %{buildroot}%{_sysconfdir}/httpd/conf.d/graphite-web.conf
install -Dp -m0644 conf/graphite.wsgi.example \
    %{buildroot}%{_datadir}/graphite/graphite-web.wsgi

# Configure django /media/ location.
sed -i 's|##PYTHON_SITELIB##|%{python_sitelib}|' \
    %{buildroot}%{_sysconfdir}/httpd/conf.d/graphite-web.conf

# Log rotation.
install -D -p -m0644 %{SOURCE10} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# Remove unneeded binaries.
rm -f %{buildroot}%{_bindir}/run-graphite-devel-server.py

# Rename build-index.sh.
mv %{buildroot}%{_bindir}/build-index.sh %{buildroot}%{_bindir}/graphite-build-index

# Make manage.py available at an easier location.
ln -s %{python_sitelib}/graphite/manage.py \
    %{buildroot}%{_bindir}/graphite-manage

# Fix permissions.
chmod 0644 conf/graphite.wsgi.example
chmod 0755 %{buildroot}%{python_sitelib}/graphite/manage.py
chmod 0644 %{buildroot}%{_datadir}/graphite/webapp/content/js/window/*


%files
%doc README.fedora LICENSE conf/* examples/*

%dir %{_sysconfdir}/graphite-web
%config(noreplace) %{_sysconfdir}/httpd/conf.d/graphite-web.conf
%config(noreplace) %{_sysconfdir}/graphite-web/dashboard.conf
%config(noreplace) %{_sysconfdir}/graphite-web/local_settings.py*
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}

%{_bindir}/graphite-build-index
%{_bindir}/graphite-manage
%{_datadir}/graphite
%attr(0755,apache,apache) %dir %{_localstatedir}/lib/graphite-web
%attr(0755,apache,apache) %dir %{_localstatedir}/log/graphite-web

%{python_sitelib}/graphite/
%{python_sitelib}/graphite_web-*-py?.?.egg-info


%changelog
* Fri Mar 20 2015 Django <django@mailserver.guru> - 0.9.12-1
Initial build for CentOS 7
